<id>
Gravatar Support for YaBB 2.5
</id>

<version>
1.1
</version>

<mod info>
Description
-----------
This mod will allow members to use the Gravatar service for their profile avatar.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload Favatar.jpg to the default images directory in Binary mode.
4) Go to Admin Center => Forum Settings => Members tab to enable the setting.
 
Files to edit
------------- 
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Profile.lng
Sources/Load.pl
Sources/Profile.pl
Sources/System.pl

Version History
---------------
V1.0 - First Release - 23rd June 2009
V1.1 - Updated for YaBB 2.5 - 10th May 2012
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$gravatar_support_mod = "Gravatar Support|Derek Barnstorm|This mod will allow members to use the Gravatar service for their profile avatar.|1.1|10th May 2012";
	push (@installed_mods, "$gravatar_support_mod");
	
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$avatar_dirlimit = $avatar_dirlimit;			# set to the maximum size of the upload avatar directory, 0 == no limit
</search for>

<add after>
\$enable_gravatar = $enable_gravatar;    # Set to 1 to enable members to use Gravatar
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
			name => 'avatar_dirlimit',
			validate => 'number',
			depends_on => ['allowpics','upload_useravatar'],
		},
</search for>

<add after>
		{
			description => qq~<label for="enable_gravatar">$admin_txt{'gravatar'}</label>~,
			input_html => qq~<input type="checkbox" name="enable_gravatar" id="enable_gravatar" value="1"${ischecked($enable_gravatar)} />~,
			name => 'enable_gravatar',
			validate => 'boolean',
			depends_on => ['allowpics'],
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%floodtxt = (
</search for>

<add before>
'gravatar' => 'Enable Gravatar Support?<br /><span class ="small">Checking this option will allow members to use the <a href="http://www.gravatar.com" target="_blank">Gravatar</a> service for their profile avatar.</span>',
</add before>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
);

%mycenter_profile_txt = (
</search for>

<add before>
'gravatar' => 'Use Gravatar?',
'gravatar_desc' => 'If you have a Gravatar associated with the email address which you registered with on this forum, you should see your Gravatar opposite. Else you can enter the email address for the Gravatar you want to use.<br />Note that checking this option will override your Personalized Picture.',
'gravatar_help' => 'What\'s a Gravatar?',
'gravatar_email' => 'Gravatar email address',
'gravatar_email_invalid' => 'Please enter a valid Gravatar email address.',
</add before>

<edit file>
Sources/Load.pl
</edit file>

<search for>
	} else {
		${$uid.$user}{'userpic'} = '<br />';
	}
</search for>

<add before>
        if ($enable_gravatar && ${$uid.$user}{'gravatar'}) {
            use Digest::MD5 qw(md5_hex);
            if (${$uid.$user}{'gravatar_email'}) { $gravatar_email = lc(${$uid.$user}{'gravatar_email'}); }
            else { $gravatar_email = lc(${$uid.$user}{'email'}); }
            $gravatar_defaulturl = "$defaultimagesdir/Favatar.jpg";
            $gravatar_defaulturl =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
            $gravatar_url = "http://www.gravatar.com/avatar/" . md5_hex($gravatar_email) . "&d=" . $gravatar_defaulturl . "&s=80";
            ${$uid.$user}{'userpic'} = qq~<img src="$gravatar_url" alt="" border="" name="avatar_img_resize" style="display: none;" /><br />~;
        }
</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
			<input type="file" name="file_avatar" size="50" />~ : "") . qq~
		</td>
	</tr>~;
	}
</search for>

<add after>

    if ($allowpics && $enable_gravatar) {
        use Digest::MD5 qw(md5_hex);
        if (${$uid.$user}{'gravatar_email'}) { $gravatar_email = lc(${$uid.$user}{'gravatar_email'}); }
        else { $gravatar_email = lc(${$uid.$user}{'email'}); }
        $gravatar_defaulturl = "$defaultimagesdir/Favatar.jpg";
        $gravatar_defaulturl =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
        $gravatar_url = "http://www.gravatar.com/avatar/" . md5_hex($gravatar_email) . "&d=" . $gravatar_defaulturl . "&s=80";
        my $grav_email_desc = "";
        if (!${$uid.$user}{'gravatar_email'}) {
            ${$uid.$user}{'gravatar_email'} = $profile_txt{'gravatar_email'};
            $grav_email_desc = qq~ onfocus="txtInFields(this, '$profile_txt{'gravatar_email'}');" onblur="txtInFields(this, '$profile_txt{'gravatar_email'}')"~;
        }
        $showProfile .= qq~
	<tr class="windowbg">
		<td align="left"><label for="gravatar"><b>$profile_txt{'gravatar'}</b><br /><span class="small">$profile_txt{'gravatar_desc'}</span></label></td>
		<td align="left"><div style="margin: 0px 0px 10px;"><img src="$gravatar_url" alt="" border="" name="avatar_img_resize" style="display: none;" /></div><input type="checkbox" name="gravatar" id="gravatar" value="1"~ . (${$uid.$user}{'gravatar'} ? ' checked="checked"' : '') . qq~ />&nbsp;<input type="text" name="gravatar_email" size="40" value="${$uid.$user}{'gravatar_email'}"$grav_email_desc /><br /><a href="http://gravatar.com" target="_blank" class="small">$profile_txt{'gravatar_help'}</a></td>
	</tr>~;
    }
</add after>

<search for>
	&FromChars($member{'signature'});
</search for>

<add before>
    if ($member{'gravatar_email'} && $member{'gravatar_email'} ne $profile_txt{'gravatar_email'}) {
        &fatal_error("invalid_character","$profile_txt{'gravatar_email'} $profile_txt{'241e'}") if $member{'gravatar_email'} !~ /^[\w\-\.\+]+\@[\w\-\.\+]+\.\w{2,4}$/;
        &fatal_error("",,"$profile_txt{'gravatar_email_invalid'}") if ($member{'gravatar_email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($member{'gravatar_email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/);
    }
    
    &ToHTML($member{'gravatar_email'});
</add before>

<search for>
	${$uid.$user}{'userpic'} = $member{'userpic'};
</search for>

<add after>
	${$uid.$user}{'gravatar'} = $member{'gravatar'} ? 1 : 0;
	${$uid.$user}{'gravatar_email'} = $member{'gravatar_email'} if $member{'gravatar_email'} ne $profile_txt{'gravatar_email'};
</add after>

<search for>
			$pic = qq~<img src="$facesurl/${$uid.$user}{'userpic'}" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		}
</search for>

<add after>
		if ($enable_gravatar && ${$uid.$user}{'gravatar'}) {
            use Digest::MD5 qw(md5_hex);
            if (${$uid.$user}{'gravatar_email'}) { $gravatar_email = lc(${$uid.$user}{'gravatar_email'}); }
            else { $gravatar_email = lc(${$uid.$user}{'email'}); }
            $gravatar_defaulturl = "$defaultimagesdir/Favatar.jpg";
            $gravatar_defaulturl =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
            $gravatar_url = "http://www.gravatar.com/avatar/" . md5_hex($gravatar_email) . "&d=" . $gravatar_defaulturl . "&s=80";
            $pic = qq~<img src="$gravatar_url" alt="" border="" name="avatar_img_resize" style="display: none;" />~;
        }
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	if ($extendedprofiles) {
		require "$sourcedir/ExtendedProfiles.pl";
</search for>

<add before>
	push(@tags, "gravatar", "gravatar_email");
</add before>